import { Component } from '@angular/core';
import {NgForOf} from "@angular/common";
import {NzTabComponent, NzTabSetComponent} from "ng-zorro-antd/tabs";
import {RouterOutlet} from "@angular/router";

@Component({
  selector: 'app-tab',
  standalone: true,
  imports: [
    NgForOf,
    NzTabComponent,
    NzTabSetComponent,
    RouterOutlet
  ],
  templateUrl: './tab.component.html',
  styleUrl: './tab.component.less'
})
export class TabComponent {
  tabs = ['首页' , '商户管理'];
}
